--
-- Filename: joinServerRequestSynch.lua
-- Author: Martin Fabík (LoogleCZ)
--
-- This event is part of NotesMod.
--

joinServerRequestSynch = {};
joinServerRequestSynch_mt = Class(joinServerRequestSynch, Event);

InitEventClass(joinServerRequestSynch, "joinServerRequestSynch");

function joinServerRequestSynch:emptyNew()
    local self = Event:new(joinServerRequestSynch_mt);
    return self;
end;

function joinServerRequestSynch:new()
    local self = joinServerRequestSynch:emptyNew();
    return self;
end;

function joinServerRequestSynch:readStream(streamId, connection)
	g_currentMission.NotesBase.notes = {};
	local number = streamReadInt16(streamId);
	for i = 1, number do
		local note = {};
		note.name = streamReadString(streamId);
		note.content = streamReadString(streamId);
		note.author = streamReadString(streamId);
		table.insert(g_currentMission.NotesBase.notes, note);
	end;
	g_currentMission.NotesBase.settings.userAddNotes = streamReadInt8(streamId);
	g_currentMission.NotesBase.settings.userDeleteNotes = streamReadInt8(streamId);
	g_currentMission.NotesBase.settings.usersEditNotes = streamReadInt8(streamId);
	g_currentMission.NotesBase.settings.userMaxNoteCount = streamReadInt8(streamId);
	g_currentMission.NotesBase.settings.afterEditNote = streamReadInt8(streamId);
	self:run(connection);
end;

function joinServerRequestSynch:writeStream(streamId, connection)
	local number = table.getn(g_currentMission.NotesBase.notes);
	streamWriteInt16(streamId, number);
	for i = 1, number do
		if g_currentMission.NotesBase.notes[i].name == nil then
			streamWriteString(streamId, "");
		else
			streamWriteString(streamId, g_currentMission.NotesBase.notes[i].name);
		end;
		if g_currentMission.NotesBase.notes[i].content == nil then
			streamWriteString(streamId, "");
		else
			streamWriteString(streamId, g_currentMission.NotesBase.notes[i].content);
		end;
		streamWriteString(streamId, g_currentMission.NotesBase.notes[i].author);
	end;
	streamWriteInt8(streamId, g_currentMission.NotesBase.settings.userAddNotes);
	streamWriteInt8(streamId, g_currentMission.NotesBase.settings.userDeleteNotes);
	streamWriteInt8(streamId, g_currentMission.NotesBase.settings.usersEditNotes);
	streamWriteInt8(streamId, g_currentMission.NotesBase.settings.userMaxNoteCount);
	streamWriteInt8(streamId, g_currentMission.NotesBase.settings.afterEditNote);
end;

function joinServerRequestSynch:run(connection)
	for k,v in pairs(g_currentMission.NotesBase.notes) do
		Notes:drawNote(v);
	end;
	g_currentMission.NotesBase.itemList:checkScrollButtons();
	
	g_currentMission.NotesBase.settingsGUIElements.userAddEditPerm:setHighestVisibleEntry(g_currentMission.NotesBase.settings.userAddNotes);
	g_currentMission.NotesBase.settingsGUIElements.userDeletePerm:setHighestVisibleEntry(g_currentMission.NotesBase.settings.userDeleteNotes);
	g_currentMission.NotesBase.settingsGUIElements.userEditPerm:setHighestVisibleEntry(g_currentMission.NotesBase.settings.usersEditNotes);
	g_currentMission.NotesBase.settingsGUIElements.maxItemsPerUserPerm:setHighestVisibleEntry(g_currentMission.NotesBase.settings.userMaxNoteCount);
	g_currentMission.NotesBase.settingsGUIElements.afterEditPerm:setHighestVisibleEntry(g_currentMission.NotesBase.settings.afterEditNote);
end;